<?php
namespace Teknisa\SM\Factory;
use Doctrine\ORM\EntityManager;

class SmRelatorioPropostaDataSourceFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Busca os dados para a tela sem ou com filtro
     */
    public function find(array $params, $page, array $filtros) {
        $sql = "SELECT * FROM (
                    SELECT ROWNUM AS IND,
                    BASE.*
                    FROM (SELECT DISTINCT 
                            ORC.NRSEQORCAMENTO,
                        	ORC.NRORCAMENTOMODELO,
                        	ORC.NRORG,
                            ORC.NRORCAMENTO,
                            ORC.NRVERSAOORCAMENTO,
                            ORC.IDSITUACAOORCAMENTO,
                            ORC.DTREFORCAMENTO,
                            ORC.DTACEITEORCA,
                            ORC.CDOPERRESPONSAVEL,
                        	ORC.NRPARCNEGOCIO,
                        	ORC.DTVALIDADE, 
                        	ORC.IDATIVO,
                        	ORC.DTINCLUSAO,
                        	ORC.NRORGINCLUSAO,
                        	ORC.NRSEQORCAMENTOPAI,
                        	ORC.IDGERACONTRATO,
                        	ORC.NRSEQINTERLOCUTOR,
                        	ORC.DSREFERENCIAORCA,
                        	ORC.CDPRECBASESERV,
                            NVL(ORC.VRORCAMENTO, 0) AS VRORCAMENTO,
                        	MODELO.NMORCAMENTOMODELO,
                            PARC.NMPRINCIPALPARC,
                            OPER.NMOPERADOR AS NMOPERRESPONSAVEL,
                            MODELO.IDUTILIZACOMP,
                            NVL(ORC.NMPARCINTERLOCUTOR, INTERLOCUTOR.NMINTERLOCUTOR) AS NMPARCINTERLOCUTOR,
                            (SELECT LISTAGG(ESCOPO.NMTIPOORCAMENTO) WITHIN GROUP (ORDER BY ESCOPO.NMTIPOORCAMENTO)
                             FROM FCT_RELACESCOPOPROPOSTA REL
                             LEFT JOIN FCT_TIPOORCAMENTO ESCOPO
                                ON REL.NRTIPOORCAMENTO = ESCOPO.NRTIPOORCAMENTO
                                AND REL.NRORG          = ESCOPO.NRORG
                             WHERE NRSEQORCAMENTO = ORC.NRSEQORCAMENTO) AS NMTIPOORCAMENTO,
                            (SELECT LISTAGG(ESCOPO.IDUTILIZAVARPRECO, ',') WITHIN GROUP( ORDER BY ESCOPO.NMTIPOORCAMENTO) 
                             FROM FCT_TIPOORCAMENTO ESCOPO 
                             INNER JOIN FCT_RELACESCOPOPROPOSTA REL 
                                ON ESCOPO.NRTIPOORCAMENTO = REL.NRTIPOORCAMENTO 
                                AND ESCOPO.NRORG          = REL.NRORG 
                             WHERE REL.NRSEQORCAMENTO = ORC.NRSEQORCAMENTO 
                                AND REL.NRORG         = ORC.NRORG) AS IDUTILIZAVARPRECO,
                            (SELECT COUNT(*)
                             FROM FCT_ITEMORCAMENTO 
                             WHERE NRSEQORCAMENTO = ORC.NRSEQORCAMENTO
                                AND NRORG         = ORC.NRORG
                                AND IDELEMENTO IS NOT NULL) AS QTITENSTRABSERV
                        FROM FCT_ORCAMENTO ORC 
                        LEFT JOIN PARCNEGOCIO PARC
                        	ON ORC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                        	AND ORC.NRORG        = PARC.NRORG
                        LEFT JOIN FCT_ORCAMENTOMODELO MODELO
                        	ON ORC.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
                        	AND ORC.NRORG            = MODELO.NRORG
                        LEFT JOIN FCT_RELACESCOPOPROPOSTA REL
                        	ON ORC.NRSEQORCAMENTO = REL.NRSEQORCAMENTO
                        	AND ORC.NRORG         = REL.NRORG
                        LEFT JOIN FILIAL
                        	ON REL.CDFILIAL = FILIAL.CDFILIAL
                        	AND REL.NRORG   = FILIAL.NRORG
                        LEFT JOIN OPERADOR OPER
                        	ON ORC.CDOPERRESPONSAVEL = OPER.CDOPERADOR
                        	AND ORC.NRORG            = OPER.NRORG
                        LEFT JOIN FCT_ITEMORCAMENTO ITEM
                            ON ORC.NRSEQORCAMENTO    = ITEM.NRSEQORCAMENTO   
                            AND ORC.NRORG            = ITEM.NRORG 
                        LEFT JOIN FCT_TIPOMEDIDASERV ITEMMED
                            ON ITEM.CDTPMEDIDAVARIAVEL = ITEMMED.CDTPMEDIDASERV
                            AND ITEM.NRORG             = ITEMMED.NRORG
                        LEFT JOIN FCT_TRABSERVORCAMENTO ELEMENTO
                            ON ORC.NRSEQORCAMENTO    = ELEMENTO.NRSEQORCAMENTO   
                            AND ORC.NRORG            = ELEMENTO.NRORG 
                            AND ELEMENTO.IDELEMENTO   IS NOT NULL
                            AND ELEMENTO.IDATIVO      = 'S'
                            AND ELEMENTO.IDESCOLHIDO  = 'S'
                        LEFT JOIN FCT_RELACMEDIDAPROPOSTA MEDIDA
                            ON ORC.NRSEQORCAMENTO = MEDIDA.NRSEQORCAMENTO
                            AND ORC.NRORG         = MEDIDA.NRORG
                        LEFT JOIN CRM_INTERLOCUTOR INTERLOCUTOR
                            ON ORC.NRSEQINTERLOCUTOR = INTERLOCUTOR.NRSEQINTERLOCUTOR
                            AND ORC.NRORG            = INTERLOCUTOR.NRORG
                        LEFT JOIN FCT_VENDEDORORCA VENDEDOR
                            ON ORC.NRSEQORCAMENTO = VENDEDOR.NRSEQORCAMENTO
                            AND ORC.NRORG          = VENDEDOR.NRORG
                        LEFT JOIN CRM_OPORTUNI OPORT
                            ON ORC.NRSEQOPORT = OPORT.NRSEQOPORT
                            AND ORC.NRORG     = OPORT.NRORG
                        LEFT JOIN (SELECT NRORG,
                                          CDOPERADOR,
                                          IDOPERMASTER,
                                          CDFILIAL
                                   FROM FCT_HIERARQUIAOPER
                                   WHERE CDOPERADOR = :CDOPERADORLOGADO) HIERARPAI
                          ON HIERARPAI.NRORG = ORC.NRORG
                        LEFT JOIN CRM_HIERARQUIAOPER HIERAR		
                          ON ORC.CDOPERRESPONSAVEL = HIERAR.CDOPERADOR
                          AND ORC.NRORG            = HIERAR.NRORG
                        LEFT JOIN FCT_PARAMETROGERAL PARAM
                          ON PARAM.NRORG                 = ORC.NRORG
                        WHERE ORC.NRORG = :NRORG
                            AND ((PARAM.IDUTILIZAHIEROPER  = 'N')
                            OR (PARAM.IDUTILIZAHIEROPER      = 'S'
                                AND (((REL.CDFILIAL = HIERARPAI.CDFILIAL OR ORC.CDFILIAL IS NULL)
                                       AND (ORC.CDOPERRESPONSAVEL IN (SELECT CDOPERADOR
                                                                           FROM FCT_HIERARQUIAOPER
                                                                           WHERE (FCT_HIERARQUIAOPER.CDFILIAL   = HIERARPAI.CDFILIAL
                                                                                OR FCT_HIERARQUIAOPER.CDFILIAL IS NULL )
                                                                           CONNECT BY PRIOR FCT_HIERARQUIAOPER.NRHIERARQUIAOPER = FCT_HIERARQUIAOPER.NRHIERARQUIAPAI
                                                                           START WITH FCT_HIERARQUIAOPER.CDOPERADOR             = HIERARPAI.CDOPERADOR))
                            OR ORC.CDOPERRESPONSAVEL IS NULL
                            OR ORC.CDOPERRESPONSAVEL  = :CDOPERADORLOGADO)
                            OR (HIERARPAI.IDOPERMASTER     = 'S'))))";
        
        if(count($filtros) > 0) {                    
            if(array_key_exists("NRSEQORCAMENTO", $filtros))
                $sql .= "AND ORC.NRSEQORCAMENTO IN(". $filtros["NRSEQORCAMENTO"] . ")";
                
            if(array_key_exists("NRPARCNEGOCIO", $filtros))
                $sql .= "AND ORC.NRPARCNEGOCIO IN(". $filtros["NRPARCNEGOCIO"]. ")";
            
            if(array_key_exists("NRVERSAOORCAMENTO", $filtros))
                $sql .= "AND ORC.NRVERSAOORCAMENTO IN(". $filtros["NRVERSAOORCAMENTO"]. ")";
            
            if(array_key_exists("IDSITUACAOORCAMENTO", $filtros))
                $sql .= "AND ORC.IDSITUACAOORCAMENTO IN('". $filtros["IDSITUACAOORCAMENTO"]. "')";
            
            if(array_key_exists("CDFILIAL", $filtros))
                $sql .= "AND ORC.CDFILIAL IN(". $filtros["CDFILIAL"]. ")";
                
            if(array_key_exists("NRORCAMENTOMODELO", $filtros))
                $sql .= "AND ORC.NRORCAMENTOMODELO IN(". $filtros["NRORCAMENTOMODELO"]. ")";
            
            if(array_key_exists("NRTIPOORCAMENTO", $filtros))
                $sql .= "AND ORC.NRTIPOORCAMENTO IN(". $filtros["NRTIPOORCAMENTO"]. ")";
            
            if(array_key_exists("NMFILIAL", $filtros))
                $sql .= "AND ORC.NMFILIAL IN(". $filtros["NMFILIAL"]. ")";
            
            if(array_key_exists("CDOPERRESPONSAVEL", $filtros))
                $sql .= "AND ORC.CDOPERRESPONSAVEL IN('". $filtros["CDOPERRESPONSAVEL"]. "')";
            
            if(array_key_exists("NMOPERRESPONSAVEL", $filtros))
                $sql .= "AND ORC.NMOPERRESPONSAVEL IN(". $filtros["NMOPERRESPONSAVEL"]. ")";
            
            if(array_key_exists("NMPRINCIPALPARC", $filtros))
                $sql .= "AND ORC.NMPRINCIPALPARC IN(". $filtros["NMPRINCIPALPARC"]. ")";
            
            if(array_key_exists("IDELEMENTO", $filtros))
                $sql .= "AND ELEMENTO.IDELEMENTO IN('". $filtros["IDELEMENTO"]. "')";
            
            if(array_key_exists("CDSERVORCA", $filtros))
                $sql .= "AND ITEM.CDSERVORCA IN(". $filtros["CDSERVORCA"]. ")";
            
            if(array_key_exists("DTREFORCAMENTO", $filtros))
                $sql .= "AND ORC.DTREFORCAMENTO BETWEEN TO_DATE('". $filtros["DTREFORCAMENTO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTREFORCAMENTO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTACEITEORCA", $filtros))
                $sql .= "AND ORC.DTACEITEORCA BETWEEN TO_DATE('". $filtros["DTACEITEORCA"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTACEITEORCA"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("NRSEQINTERLOCUTOR", $filtros))
                $sql .= "AND INTERLOCUTOR.NRSEQINTERLOCUTOR IN(". $filtros["NRSEQINTERLOCUTOR"] . ")";
                
            if(array_key_exists("NRVENDEDOR", $filtros))
                $sql .= "AND VENDEDOR.NRPARCVENDEDOR IN(". $filtros["NRVENDEDOR"] . ")";
                
            if(array_key_exists("NRSEQOPORT", $filtros))
                $sql .= "AND OPORT.NRSEQOPORT IN(". $filtros["NRSEQOPORT"] . ")";
                
            if(array_key_exists("CDTPMEDIDASERV", $filtros))
                $sql .= "AND (MEDIDA.CDTPMEDIDAVARIAVEL IN(". $filtros["CDTPMEDIDASERV"] . ") OR ITEM.CDTPMEDIDASERV IN(". $filtros["CDTPMEDIDASERV"] . "))";
        }
        
        $sql .= " ORDER BY NRSEQORCAMENTO DESC) BASE ) TBL ";
        
        if ($page != null){
            $sql .= " WHERE (IND > " . (($page - 1) * 50) . " AND IND <= " . $page * 50 . ")";
        }
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    /**
     * Busca os dados para a tela sem ou com filtro
     */
    public function findItens(array $params, array $filtros) {
        $sql = "SELECT DISTINCT 
                    ORC.NRSEQORCAMENTO,
                    DECODE(ITEM.IDELEMENTO, NULL, ORC.NRORCAMENTO, NULL) AS NRORCAMENTO,
                    ITEM.NRITEMORCAMENTO,
                    ITEM.NRITEMORCAMENTOPAI,
                    ITEM.NMITEMORCAMENTO,
                    DECODE(ITEM.IDELEMENTO, NULL, NULL, DECODE(NVL(ITEM.QTMEDIDAORCA, 0), 0, '0,00', TO_CHAR(ITEM.QTMEDIDAORCA, 'FM999G999G999D90', 'nls_numeric_characters='',.'''))) AS QTMEDIDAORCA,
                    ITEM.VRTOTALITEMORCA,
                    DECODE(ITEM.IDELEMENTO, NULL, NULL, ITEMMED.DSTPMEDIDASERV) AS DSTPMEDIDASERV
                FROM FCT_ORCAMENTO ORC 
                LEFT JOIN PARCNEGOCIO PARC
                	ON ORC.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                	AND ORC.NRORG        = PARC.NRORG
                LEFT JOIN FCT_ORCAMENTOMODELO MODELO
                	ON ORC.NRORCAMENTOMODELO = MODELO.NRORCAMENTOMODELO
                	AND ORC.NRORG            = MODELO.NRORG
                LEFT JOIN FCT_RELACESCOPOPROPOSTA REL
                	ON ORC.NRSEQORCAMENTO = REL.NRSEQORCAMENTO
                	AND ORC.NRORG         = REL.NRORG
                LEFT JOIN FILIAL
                	ON REL.CDFILIAL = FILIAL.CDFILIAL
                	AND REL.NRORG   = FILIAL.NRORG
                LEFT JOIN OPERADOR OPER
                	ON ORC.CDOPERRESPONSAVEL = OPER.CDOPERADOR
                	AND ORC.NRORG            = OPER.NRORG
                LEFT JOIN FCT_ITEMORCAMENTO ITEM
                    ON ORC.NRSEQORCAMENTO    = ITEM.NRSEQORCAMENTO   
                    AND ORC.NRORG            = ITEM.NRORG 
                LEFT JOIN FCT_TIPOMEDIDASERV ITEMMED
                    ON ITEM.CDTPMEDIDAVARIAVEL = ITEMMED.CDTPMEDIDASERV
                    AND ITEM.NRORG             = ITEMMED.NRORG
                LEFT JOIN FCT_TRABSERVORCAMENTO ELEMENTO
                    ON ORC.NRSEQORCAMENTO    = ELEMENTO.NRSEQORCAMENTO   
                    AND ORC.NRORG            = ELEMENTO.NRORG 
                    AND ELEMENTO.IDELEMENTO   IS NOT NULL
                    AND ELEMENTO.IDATIVO      = 'S'
                    AND ELEMENTO.IDESCOLHIDO  = 'S'
                LEFT JOIN FCT_RELACMEDIDAPROPOSTA MEDIDA
                    ON ORC.NRSEQORCAMENTO = MEDIDA.NRSEQORCAMENTO
                    AND ORC.NRORG         = MEDIDA.NRORG
                LEFT JOIN CRM_INTERLOCUTOR INTERLOCUTOR
                    ON ORC.NRSEQINTERLOCUTOR = INTERLOCUTOR.NRSEQINTERLOCUTOR
                    AND ORC.NRORG            = INTERLOCUTOR.NRORG
                LEFT JOIN FCT_VENDEDORORCA VENDEDOR
                    ON ORC.NRSEQORCAMENTO = VENDEDOR.NRSEQORCAMENTO
                    AND ORC.NRORG          = VENDEDOR.NRORG
                LEFT JOIN CRM_OPORTUNI OPORT
                    ON ORC.NRSEQOPORT = OPORT.NRSEQOPORT
                    AND ORC.NRORG     = OPORT.NRORG
                LEFT JOIN (SELECT NRORG,
                                  CDOPERADOR,
                                  IDOPERMASTER,
                                  CDFILIAL
                           FROM FCT_HIERARQUIAOPER
                           WHERE CDOPERADOR = :CDOPERADORLOGADO) HIERARPAI
                  ON HIERARPAI.NRORG = ORC.NRORG
                LEFT JOIN CRM_HIERARQUIAOPER HIERAR		
                  ON ORC.CDOPERRESPONSAVEL = HIERAR.CDOPERADOR
                  AND ORC.NRORG            = HIERAR.NRORG
                LEFT JOIN FCT_PARAMETROGERAL PARAM
                  ON PARAM.NRORG                 = ORC.NRORG
                WHERE ORC.NRORG = :NRORG
                    AND ((PARAM.IDUTILIZAHIEROPER  = 'N')
                    OR (PARAM.IDUTILIZAHIEROPER      = 'S'
                        AND (((REL.CDFILIAL = HIERARPAI.CDFILIAL OR ORC.CDFILIAL IS NULL)
                               AND (ORC.CDOPERRESPONSAVEL IN (SELECT CDOPERADOR
                                                                   FROM FCT_HIERARQUIAOPER
                                                                   WHERE (FCT_HIERARQUIAOPER.CDFILIAL   = HIERARPAI.CDFILIAL
                                                                        OR FCT_HIERARQUIAOPER.CDFILIAL IS NULL )
                                                                   CONNECT BY PRIOR FCT_HIERARQUIAOPER.NRHIERARQUIAOPER = FCT_HIERARQUIAOPER.NRHIERARQUIAPAI
                                                                   START WITH FCT_HIERARQUIAOPER.CDOPERADOR             = HIERARPAI.CDOPERADOR))
                    OR ORC.CDOPERRESPONSAVEL IS NULL
                    OR ORC.CDOPERRESPONSAVEL  = :CDOPERADORLOGADO)
                    OR (HIERARPAI.IDOPERMASTER     = 'S'))))";
        
        if(count($filtros) > 0) {                    
            if(array_key_exists("NRSEQORCAMENTO", $filtros))
                $sql .= "AND ORC.NRSEQORCAMENTO IN(". $filtros["NRSEQORCAMENTO"] . ")";
                
            if(array_key_exists("NRPARCNEGOCIO", $filtros))
                $sql .= "AND ORC.NRPARCNEGOCIO IN(". $filtros["NRPARCNEGOCIO"]. ")";
            
            if(array_key_exists("NRVERSAOORCAMENTO", $filtros))
                $sql .= "AND ORC.NRVERSAOORCAMENTO IN(". $filtros["NRVERSAOORCAMENTO"]. ")";
            
            if(array_key_exists("IDSITUACAOORCAMENTO", $filtros))
                $sql .= "AND ORC.IDSITUACAOORCAMENTO IN('". $filtros["IDSITUACAOORCAMENTO"]. "')";
            
            if(array_key_exists("CDFILIAL", $filtros))
                $sql .= "AND ORC.CDFILIAL IN(". $filtros["CDFILIAL"]. ")";
                
            if(array_key_exists("NRORCAMENTOMODELO", $filtros))
                $sql .= "AND ORC.NRORCAMENTOMODELO IN(". $filtros["NRORCAMENTOMODELO"]. ")";
            
            if(array_key_exists("NRTIPOORCAMENTO", $filtros))
                $sql .= "AND ORC.NRTIPOORCAMENTO IN(". $filtros["NRTIPOORCAMENTO"]. ")";
            
            if(array_key_exists("NMFILIAL", $filtros))
                $sql .= "AND ORC.NMFILIAL IN(". $filtros["NMFILIAL"]. ")";
            
            if(array_key_exists("CDOPERRESPONSAVEL", $filtros))
                $sql .= "AND ORC.CDOPERRESPONSAVEL IN('". $filtros["CDOPERRESPONSAVEL"]. "')";
            
            if(array_key_exists("NMOPERRESPONSAVEL", $filtros))
                $sql .= "AND ORC.NMOPERRESPONSAVEL IN(". $filtros["NMOPERRESPONSAVEL"]. ")";
            
            if(array_key_exists("NMPRINCIPALPARC", $filtros))
                $sql .= "AND ORC.NMPRINCIPALPARC IN(". $filtros["NMPRINCIPALPARC"]. ")";
            
            if(array_key_exists("IDELEMENTO", $filtros))
                $sql .= "AND ELEMENTO.IDELEMENTO IN('". $filtros["IDELEMENTO"]. "')";
            
            if(array_key_exists("CDSERVORCA", $filtros))
                $sql .= "AND ITEM.CDSERVORCA IN(". $filtros["CDSERVORCA"]. ")";
            
            if(array_key_exists("DTREFORCAMENTO", $filtros))
                $sql .= "AND ORC.DTREFORCAMENTO BETWEEN TO_DATE('". $filtros["DTREFORCAMENTO"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTREFORCAMENTO"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("DTACEITEORCA", $filtros))
                $sql .= "AND ORC.DTACEITEORCA BETWEEN TO_DATE('". $filtros["DTACEITEORCA"][0]. "', 'DD/MM/YYYY') AND TO_DATE('". $filtros["DTACEITEORCA"][1] . "', 'DD/MM/YYYY')";
                
            if(array_key_exists("NRSEQINTERLOCUTOR", $filtros))
                $sql .= "AND INTERLOCUTOR.NRSEQINTERLOCUTOR IN(". $filtros["NRSEQINTERLOCUTOR"] . ")";
                
            if(array_key_exists("NRVENDEDOR", $filtros))
                $sql .= "AND VENDEDOR.NRPARCVENDEDOR IN(". $filtros["NRVENDEDOR"] . ")";
                
            if(array_key_exists("NRSEQOPORT", $filtros))
                $sql .= "AND OPORT.NRSEQOPORT IN(". $filtros["NRSEQOPORT"] . ")";
                
            if(array_key_exists("CDTPMEDIDASERV", $filtros))
                $sql .= "AND (MEDIDA.CDTPMEDIDAVARIAVEL IN(". $filtros["CDTPMEDIDASERV"] . ") OR ITEM.CDTPMEDIDASERV IN(". $filtros["CDTPMEDIDASERV"] . "))";
        }
        
        $sql .= " ORDER BY ORC.NRSEQORCAMENTO DESC";
        //$sql .= " WHERE (ROWNUM > " . (($page - 1) * 50) . " AND ROWNUM <= " . $page * 50 . ")";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}
?>